# React component for DEXT5 Editor

[RAONWIZ](http://www.raonwiz.com/) / [DEXT5](https://www.dext5.com/) React component for DEXT5 Editor.

## Installation and usage

In order to create an component instance in React, install the `dext5editor-react` npm package as a dependency of your project:

```bash
npm install dext5editor-react
```

After installing, import `DEXT5Editor` to your application:

```jsx
import React from 'react';
import { DEXT5Editor } from 'dext5editor-react';

function App() {
	return <DEXT5Editor />;
}

export default App;
```

## Download DEXT5 Editor component

This React integration component must be provided with DEXT5 Editor component through the following site. (You need to sign up for this website):

[https://www.dext5.com/page/license/trial.aspx](https://www.dext5.com/page/license/trial.aspx) by visiting the site, Request a trial version of DEXT5 Editor.

Install DEXT5 Editor provided via e-mail as follows and run the sample:

```
Copy to the /samples/basic/public subdirectory.
ex) /samples/basic/public/dext5editor
```

## Documentation and samples

Please check the following file:

```
/samples/README.md
```

## React support

The DEXT5 Editor React integration was tested with React 18.

## TypeScript support

TypeScript 3.5+ is supported.

## Browser support

Previous versions of `dext5editor-react` also support Internet Explorer 11 (requires additional polyfill for `Promise`).

## License

Copyright (c) 2003-2022, RAONWIZ DevTeam. All rights reserved.