/**
 * @license Copyright (c) 2003-2022, RAONWIZ DevTeam. All rights reserved.
 */
import * as React from 'react';
import { ComponentStatus } from './types';
/**
 * Transforms `camelCaseValue` into `kebab-case-value`.
 *
 * @param str string to transform
 * @returns transformed string
 */
export declare function camelToKebab(str: string): string;
/**
 * Generates reasonably unique value of five lower-case letters.
 *
 * @returns unique value
 */
export declare function uniqueName(): string;
/**
 * Returns style for the root element.
 *
 * @param status component status
 * @param style custom style
 * @returns style
 */
export declare function getStyle(status?: ComponentStatus, style?: React.CSSProperties | null): React.CSSProperties | {
    readonly display: "none";
    readonly visibility: "hidden";
};
