import React from 'react';
import { DEXT5Editor } from 'dext5editor-react';
import { HashRouter, NavLink, Route, Routes } from 'react-router-dom';

function App() {
	return (
		<HashRouter>
			<div>
				<Routes>
					<Route path="/" element={<h1>{'Home page'}</h1>} />
					<Route path="/component" element={<DEXT5Editor
						debug={true}
						id='editor1'
						
						config={{DevelopLangage:'NONE'}}
						componentUrl="/dext5editor/js/dext5editor.js"
						initData="<p>Hello <strong>DEXT5 Editor</strong> world!</p>"
					/>} />
				</Routes>
				<div>
					<div>
						<NavLink to="/">{'Home page'}</NavLink>
					</div>
					<div>
						<NavLink to="/component">{'Component page'}</NavLink>
					</div>
				</div>
				<footer>{`Running React v${ React.version }`}</footer>
			</div>
		</HashRouter>
	);
}

export default App;
